#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <cstring>
#include <cstdio>
#include <cstdlib>
using namespace std;

vector<string> gen;

int Rand(int m){
	//on my compiler (64bit) RAND_MAX is 2147483647 !!!
	return ((rand() * RAND_MAX + rand()) & ~(1<<31)) % m;
}

string GenR(int N, string al){
	string r;
	for(int i = 0; i < N; ++i){
		r += al[Rand(al.size())];
	}
	return r;
}

string GenMul(int N, string al){
	string r;
	for(int i = 0; i < N; ++i){
		r += al;
	}
	return r;
}

string Noise(int C, string a){
	for(int i = 0; i < C; ++i){
		a.at(Rand(a.size())) = 'a' + Rand(20);
	}
	return a;
}

string GenBinary(){
	string res = "";
	for(int i = 0; i < 1 << 16; ++i){
		for(int j = 0; j < 16; ++j){
			res += ((i & 1 << j) ? 'x' : 'z');
		}
		res += '\n';
	}
	return res;
}

string GenTernary(){
	string res = "";
	char a[] = "rvm";
	int to = 81*81*9;
	for(int i = 0; i < to; ++i){
		for(int j = 1; j < to; j *= 3){
			res += a[i % (j*3) / j];
		}
		res += '\n';
	}
	return res;
}

string GenQuad(){
	string res = "";
	char a[] = "stop";
	for(int i = 0; i < 1 << 16; ++i){
		for(int j = 0; j < 16; j+=2){
			res += a[i >> j & 3];
		}
		res += '\n';
	}
	return res;
}


int main(){
	srand(5);
	//cerr << " <<<<<< " << RAND_MAX << endl;
	//1
	gen.push_back("gagagaaabaabab");
	//2
	gen.push_back("kakaribaribarak");
	//3
	gen.push_back(
		"cc\n"
		"z\n"
		"xy\n"
		"a\n"
		"abc\n"
		"cba"); //minimalistic
	//4
	gen.push_back("kakaribaribarakkakaribaribarak"); 
	//5
	gen.push_back("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"); //mono
	//6
	gen.push_back(
		"miloesupermiloesuperiniakviglupostituk\n"
		"bbaa\n"
		"abc\n"
		"asdf\n"
		"abacaba\n"
		"dfoijaebowfg\n"
		"abc\n"
		"a\n"
		"ab\n"
		"z\n"
		"cba\n"
		"cab\n"
		"aba\n"
		"aaa\n"
		"river\n"
		"homemilostuffcontpending\n"
		"azbabagica\n"
		"asdfk\n"
		"konfeti\n"
		"klaklaklakla\n"
	); 
	//7
	gen.push_back(
		"tukaimaniakvilupostiiiiiinakraiaimanidvoinaseriamilopilomilopilo\n"
		"kakaribaribarakxkakaribaribarakkakaribaribarakkakaribaribara" 	
		"kkakaribaribarakkakaribaribarakkakaribaribarakkakaribaribarakkakaribar"
		"ibarakkakaribaribarakkakaribaribarakkakaribaribarakxkakaribaribarakkak"
		"aribaribarakkakaribaribarakxkakaribaribarakkakaribaribarakkakaribariba"
		"rakxkakaribaribarakkakaribaribarakkakaribaribarakxkakaribaribarakkakar"
		"ibaribarak"); //60,60
	
	//8
	gen.push_back(GenQuad());
	//9
	gen.push_back(GenBinary());
	//10
	gen.push_back(GenTernary());
	//11
	gen.push_back("abab"+Noise(100, GenMul(200*1000, "miloeumen")));
	//12
	gen.push_back(Noise(10, GenR(1000*1000, "x")));
	//13
	gen.push_back(Noise(10, "ababababababababababababa" + GenR(1000*1000, "z")));
	//14
	gen.push_back(Noise(10, GenR(1000*1000, "x")));
	//15
	gen.push_back(Noise(10, GenMul(200*1000, "fish")));
	
	string a30000(30*1000, 'a');
	//16
	gen.push_back(Noise(20, GenR(1700*1000, a30000+"fis")));
	
	//17
	gen.push_back(Noise(120, GenR(1700*1000, a30000+"x")));
	
	//18
	gen.push_back("abab"+Noise(500000, GenMul(900*1000, "ab"))+"zz");
	
	//19
	string x100(100, 'x');
	gen.push_back(GenMul(100, "ris") + Noise(10000, GenMul(15000, x100+"z")));
	
	//20
	string temp(30*1000, 'a');
	temp += 's';
	gen.push_back(GenR(2*1000*1000, temp));
	//ofstream fo("double.in");
	for(int i = 0; i < int(gen.size()); ++i){
		char fn[64];
		sprintf(fn, "names.%02d.in", i+1);
		ofstream fo(fn);
		fo << gen[i] << (gen[i][gen[i].size()-1] == '\n' ? "" : "\n");
	}
	return 0;
}

