/*

!CBA  is to hard and will be dropped
;minimal region: a maximal (by inclusion) substring of the minimal character present

* if the string begins with minimal region:
** if there is not another minimal region, then solution should be either ABC, or ACB



by perm
	the no-split solution should be considered as possible
	
	the one split solution is solving minimal rotation
	
		
	hypothesis: if the string begins with minimal region, then only ABC or BCA should be checked and the biggest minimal region should be put in front
		

	ABC is identity
	CAB is rotation
	BCA is rotation


	ACB is possible only when all A[i] <= than all the rest
	and A is as long as possible. Then the rest is the minimal rotation problem.
	
	hypothesis: if the string begins with minimal region, then only ABC or BCA should be checked and the biggest minimal region should be put in front
	
	-dropped! CBA - C contains the last minimal region wtf?. This region is extracted and the rest is the minimal rotation problem
		C begins with some of the minimal suffuxes (starting with minimal region) suffixes 'ab' and 'abab' are equal. we should extend each suffix with the smallest suffix of the rest. Still dont know what to do...
		
		for each possible beginnings of C... solve minimal rotation for AB and check ?!
	
	
	
	BAC: B begins with minimal region (longest proper one) 
		assume we know b (the position of B)
			we extend B with all the characters <= A[0] 
			* can be checked in O(log N)
			
		BAC:
			B begins with longest minimal region, and contains all the characters such that B[i] <= A[0]
			* we can check all minimal region beginnings
		

	


*/


#include <iostream>
#include <cstring>
#include <string>
#include <cassert>
using namespace std;

#define REP(i, n) for(int i = 0; i < int(n); ++i)
#define DEB(x) //cerr << #x << ":\t" << x << " at" << __LINE__ << endl;

const int MAX = 4*1024*1024;
const char ZP = 'z' + 1;
const char AM = 'a' - 1;

char S[MAX];
char res[MAX];
int N;

void BruteCheck(){
	//checks whether res is correct
	string s = ::S;
	string best = s;
	REP(e, N+1) REP(b, e){
		string A = s.substr(0, b);
		string B = s.substr(b, e-b);
		string C = s.substr(e);
		// skip A+B+C
		best = min(best, A+C+B);
		best = min(best, B+A+C);
		best = min(best, B+C+A);
		best = min(best, C+A+B);
		//best = min(best, C+B+A); rejected by the description
	}
	if(best != res){
		cerr << "S:" << S << endl;
		cerr << "best:" << best << endl;
		cerr << "res:" << res << endl;
		DEB(best);
		DEB(res);
	}
	assert(best == res);
	
}

typedef int ht; //hash type
typedef long long dht; //can handle ht*MUL
const int MOD = 2000000011;
//typedef int dht;
//const int MOD = 60000011;//30000001;//2000003;
const int P = 29;

ht h[MAX]; //h[C] - hash of the prefix of len C
ht pows[MAX];
void InitHash(){
	h[0] = 0;
	pows[0] = 1;
	for(int i = 0; i < N; ++i){
		h[i+1] = (ht)(((dht)h[i] * P + S[i]) % MOD);
		pows[i+1] = (ht)((dht)pows[i]*P % MOD);
		//DEB(i);
		//DEB(pows[i]);
		//DEB(h[i]);
	}
}

// hash of substring starting from p with length l
ht Hash(int p, int l){
	//DEB(p);
	//DEB(l);
	
	ht res = (ht)(((dht)h[p+l] - ((dht)h[p] * pows[l] % MOD) + MOD) % MOD);
	//DEB(res);
	return res;
}

//compares two substrings of length l
int Compare(int p1, int p2, int l){ 
	int pref = 0; //longest common prefix
	int base = 1;
	while(base * 2 < l) base <<= 1;
	for(; base > 0; base >>= 1){
		int np = pref | base; //next pref
		if(np < l && Hash(p1, np) == Hash(p2, np)) pref = np;
	}
	if(l == pref) return 0;
	return (int)S[p1+pref] - S[p2+pref];
}	

// mighty function :) compares arrays of intervals
inline int Compare(int* xp, int* xl, int xn, int* yp, int* yl, int yn){
	int xi = 0; //current interval of x
	int yi = 0; //current interval of y
	int xr = 0; //processed len of cur interval..
	int yr = 0; //processed len of cur interval..
	//DEB(xn);
	//DEB(yn);
	int xts = 0; REP(i, xn) xts += xl[i];
	//DEB(xts);
	int yts = 0; REP(i, yn) yts += yl[i];
	//DEB(yts);
	assert(xts == yts); //for this problem only
	
	while(xi < xn && yi < yn){
		
		int l = min(xl[xi] - xr, yl[yi] - yr);
		//DEB(l);
		int r = Compare(xp[xi] + xr, yp[yi] + yr, l);
		if(r != 0) return r;
		xr += l;
		yr += l;
		while(xr == xl[xi] && xi < xn){
			++xi;
			xr = 0;
		}
		while(yr == yl[yi] && yi < yn){
			++yi;
			yr = 0;
		}
	}
	//DEB(xi); DEB(yi);
	assert(xi == xn && yi == yn);
	return 0;
}

struct Pair{
	int p1, l1, p2, l2;
};

struct Triplet{
	int p1, l1, p2, l2, p3, l3;
};


inline int Compare(Pair const& x, Pair const& y){
	int xp[] = {x.p1, x.p2};
	int xl[] = {x.l1, x.l2};
	int yp[] = {y.p1, y.p2};
	int yl[] = {y.l1, y.l2};
	return Compare(xp, xl, 2, yp, yl, 2);
}


inline int Compare(Triplet const& x, Triplet const& y){
	int xp[] = {x.p1, x.p2, x.p3};
	int xl[] = {x.l1, x.l2, x.l3};
	int yp[] = {y.p1, y.p2, y.p3};
	int yl[] = {y.l1, y.l2, y.l3};
	return Compare(xp, xl, 3, yp, yl, 3);
}




//best rotation problem
Pair BestRot(int p, int l){
	Pair bestRot;
	bestRot.p1 = p;
	bestRot.l1 = l;
	bestRot.p2 = 0;
	bestRot.l2 = 0;
	REP(m, l){
		//rotate 0..m, m..N-1
		Pair t;
		t.p1 = p+m;
		t.l1 = l-m;
		t.p2 = p;
		t.l2 = m;
		if(Compare(t, bestRot) < 0) bestRot = t;
	}
	return bestRot;	
}


int mrl[MAX]; //minimal region length starting from there (or 0)... a bit internal but whatever

int main(){
	while(cin >> S){
		N = strlen(S);
		//DEB(S);
		
		
		/*
		int xp[] = {2, 0};
		int xl[] = {2, 2};
		int yp[] = {0, 4};
		int yl[] = {4, 0};
		DEB(Compare(xp, xl, 2, yp, yl, 2));
		*/
		
		InitHash();
		
		//check minimal rotation (covers ABC, BCA, CAB)
		//DEB("BestRot");
		Pair bestRot = BestRot(0, N);
		//DEB(bestRot.p1);
		//DEB(bestRot.l1);
		//DEB(bestRot.p2);
		//DEB(bestRot.l2);
		
		Triplet best = {0, N, N, 0, N, 0};
		
		
		//DEB("ACB");
		// check ACB
		{
			//ACB is possible only when all A[i] <= all the rest
			//and A is as long as possible. Then the rest is the minimal rotation problem.
			
			int lastIndex[256];
			for(char c = 'a'; c <= 'z'; ++c) lastIndex[c] = -1;
			REP(i, N) lastIndex[S[i]] = i;
			
			int a = 0; //|A|
			REP(i, N){
				//can we add i-th char
				bool ok = true;
				//if there is char c < S[i] with position > i then we should stop;
				for(char c = 'a'; c < S[i]; ++c){
					if(lastIndex[c] > i){
						ok = false;
						break;
					}
				}
				if(ok) a = i+1;
				else break;
			}
			
			//now we have A
			
			//DEB(a);
			
			Pair rest = BestRot(a, N-a);
			
			DEB(rest.p1);
			DEB(rest.l1);
			DEB(rest.p2);
			DEB(rest.l2);
			
			Triplet t;
			t.p1 = 0;
			t.l1 = a;
			t.p2 = rest.p1;
			t.l2 = rest.l1;
			t.p3 = rest.p2;
			t.l3 = rest.l2;
			
			if(Compare(t, best) < 0) best = t;
		}
		
		//DEB("BAC");
		{
			//	BAC: B begins with minimal region (longest proper one) 
			//	assume we know b (the position of B)
			//		we extend B with all the characters <= A[0] 
			//		* can be checked in O(log N)
			//		
			//	BAC:
			// B begins with longest minimal region, and contains all the characters such that B[i] <= A[0]
			//		* we can check all minimal region beginnings
			
			
			char mc = S[0]; //minimal character
			REP(i, N) mc = min(mc, S[i]);
			
			//DEB(mc);
			
			
			
			
			for(int i = N; i >= 0; --i){
				if(S[i] == mc) mrl[i] = mrl[i+1] + 1;
				else mrl[i] = 0;
				
			}
			int maxReg = 0;
			{
				int m = 0;
				while(mrl[m] > 0) ++m;
				for(int i = m; i < N; ++i)	maxReg = max(maxReg, mrl[i]);
			}
			
			/*
				//check whether A have decreasing or increasing beginning
				the problem is whether B should extend with characters = A[0];
				i guess there is a good answer for this, but instead thinking of it, 
				i'll check both
				* in fact i'll check much more :)
			*/
			
			
			for(int b = 1; b < N; ++b){
				//possible beginning of B;
				//if(mrl[b] != maxReg) continue;
				if(mrl[b] < maxReg ) continue;
				DEB(b);
				
				int c = b; //the end B
				while(S[c] < S[0] && c < N) ++c;
				DEB(c);
				
				Triplet t;
				t.p1 = b;
				t.l1 = c-b;
				t.p2 = 0;
				t.l2 = b;
				t.p3 = c;
				t.l3 = N-c;
				
				if(Compare(t, best) < 0) best = t;
				
				//very very lame :/
				
				while(S[c] <= S[0] && c < N){
					 ++c;
					DEB(c);
					
					t.p1 = b;
					t.l1 = c-b;
					t.p2 = 0;
					t.l2 = b;
					t.p3 = c;
					t.l3 = N-c;
					
					if(Compare(t, best) < 0) best = t;
				}
				
			
			}
			/*
			DEB(t.p1);	
			DEB(t.l1);	
			DEB(t.p2);	
			DEB(t.l2);	
			DEB(t.p3);	
			DEB(t.l3);			
			*/

/*			DEB(best.p1);	
			DEB(best.l1);	
			DEB(best.p2);	
			DEB(best.l2);	
			DEB(best.p3);	
			DEB(best.l3);			*/
		}
		
		Triplet tripRot = {bestRot.p1, bestRot.l1, bestRot.p2, bestRot.l2, N, 0};
		if(Compare(tripRot, best) < 0) best = tripRot;
		
		/*
			DEB(best.p1);	
			DEB(best.l1);	
			DEB(best.p2);	
			DEB(best.l2);	
			DEB(best.p3);	
			DEB(best.l3);			
		*/
		int rs = 0; //size of res;
		REP(i, best.l1) res[rs++] = S[best.p1+i];
		REP(i, best.l2) res[rs++] = S[best.p2+i];
		REP(i, best.l3) res[rs++] = S[best.p3+i];
		res[rs] = 0;
		
		cout << res << "\n";
		//if(N < 1000) BruteCheck();
	}
	return 0;
}
